var search_data = {"index":{"searchIndex":["object","ronad","default","eventually","just","cannotbenil","justone","many","maybe","monad","one","default()","eventually()","just()","justone()","many()","maybe()","one()","and_then()","and_then()","and_then()","and_then()","and_then()","and_then()","continue()","expand()","from_multiple_values()","from_value()","halt()","method_missing()","monad_value()","monad_value()","monad_value()","monad_value()","monad_value()","new()","new()","new()","new()","new()","new()","respond_to_missing?()","value()"],"longSearchIndex":["object","ronad","ronad::default","ronad::eventually","ronad::just","ronad::just::cannotbenil","ronad::justone","ronad::many","ronad::maybe","ronad::monad","ronad::one","object#default()","object#eventually()","object#just()","object#justone()","object#many()","object#maybe()","object#one()","ronad::default#and_then()","ronad::eventually#and_then()","ronad::just#and_then()","ronad::many#and_then()","ronad::maybe#and_then()","ronad::one#and_then()","ronad::monad#continue()","ronad::eventually#expand()","ronad::maybe::from_multiple_values()","ronad::many#from_value()","ronad::maybe#halt()","ronad::monad#method_missing()","ronad::default#monad_value()","ronad::eventually#monad_value()","ronad::just#monad_value()","ronad::many#monad_value()","ronad::monad#monad_value()","ronad::default::new()","ronad::eventually::new()","ronad::just::new()","ronad::justone::new()","ronad::many::new()","ronad::monad::new()","ronad::monad#respond_to_missing?()","ronad::monad#value()"],"info":[["Object","","Object.html","",""],["Ronad","","Ronad.html","","<p>@nodoc\n"],["Ronad::Default","","Ronad/Default.html","","<p>A default “monad”. Not technically a monad as it take two values.\n"],["Ronad::Eventually","","Ronad/Eventually.html","","<p>Delayed execution. Similar to creating a closure but Eventually is compatible with the Ronad API.\n<p>Eventually …\n"],["Ronad::Just","","Ronad/Just.html","","<p>Useful for immediately failing when a nil pops up.\n\n<pre class=\"ruby\"><span class=\"ruby-identifier\">name</span> = <span class=\"ruby-identifier\">get_name</span>(<span class=\"ruby-identifier\">person</span>) <span class=\"ruby-comment\">#=&gt; nil</span>\n<span class=\"ruby-comment\"># ... later somewhere ...</span>\n</pre>\n"],["Ronad::Just::CannotBeNil","","Ronad/Just/CannotBeNil.html","","<p>Raised if the underlying value of Just becomes nil\n"],["Ronad::JustOne","","Ronad/JustOne.html","","<p>@deprecated @see Ronad::Maybe::from_multiple_values\n"],["Ronad::Many","","Ronad/Many.html","","<p>Chain operations on lists that can possibly return other lists.\n\n<pre>sentence = &#39;hello-there my-friend@good-bye ...</pre>\n"],["Ronad::Maybe","","Ronad/Maybe.html","",""],["Ronad::Monad","","Ronad/Monad.html","","<p>This class provides a common interface.\n<p>@abstract\n"],["Ronad::One","","Ronad/One.html","","<p>A One is similar to a Many but does not flatten the results if #and_then produces another list.\n\n<pre>urls = ...</pre>\n"],["Default","Object","Object.html#method-i-Default","(fallback, value)",""],["Eventually","Object","Object.html#method-i-Eventually","(&b)",""],["Just","Object","Object.html#method-i-Just","(value)",""],["JustOne","Object","Object.html#method-i-JustOne","(*values)",""],["Many","Object","Object.html#method-i-Many","(value, **kargs)",""],["Maybe","Object","Object.html#method-i-Maybe","(*values)",""],["One","Object","Object.html#method-i-One","(value, **kargs)",""],["and_then","Ronad::Default","Ronad/Default.html#method-i-and_then","(&block)","<p>Allows chaining on nil values with a fallback\n<p>@note The fallback does not get the transformations\n<p>@example …\n"],["and_then","Ronad::Eventually","Ronad/Eventually.html#method-i-and_then","(&block)","<p>@override\n"],["and_then","Ronad::Just","Ronad/Just.html#method-i-and_then","(&block)","<p>Similar to Maybe#and_then but raises an error if the value ever becomes nil.\n<p>@example\n\n<pre class=\"ruby\"><span class=\"ruby-identifier\">j</span> = <span class=\"ruby-constant\">Just</span>(<span class=\"ruby-string\">&#39;hello&#39;</span>) <span class=\"ruby-operator\">...</span>\n</pre>\n"],["and_then","Ronad::Many","Ronad/Many.html#method-i-and_then","(&b)",""],["and_then","Ronad::Maybe","Ronad/Maybe.html#method-i-and_then","()","<p>Allows for safe navigation on nil.\n\n<pre class=\"ruby\"><span class=\"ruby-keyword\">nil</span>&amp;.<span class=\"ruby-identifier\">m1</span>&amp;.<span class=\"ruby-identifier\">m2</span>&amp;.<span class=\"ruby-identifier\">m3</span> <span class=\"ruby-comment\">#=&gt; nil</span>\n\n<span class=\"ruby-operator\">~</span><span class=\"ruby-constant\">Maybe</span>(<span class=\"ruby-keyword\">nil</span>).<span class=\"ruby-identifier\">m1</span>.<span class=\"ruby-identifier\">m2</span>.<span class=\"ruby-identifier\">m3</span> <span class=\"ruby-comment\">#=&gt; nil</span>\n</pre>\n<p>Using a Maybe …\n"],["and_then","Ronad::One","Ronad/One.html#method-i-and_then","(&b)",""],["continue","Ronad::Monad","Ronad/Monad.html#method-i-continue","()","<p>“Fails” a maybe given a certain condition. If the condition is `false` then Maybe(nil) will …\n"],["expand","Ronad::Eventually","Ronad/Eventually.html#method-i-expand","(val)","<p>@note can probably replace monad_value\n"],["from_multiple_values","Ronad::Maybe","Ronad/Maybe.html#method-c-from_multiple_values","(*vals)","<p>Creates a single Maybe from multiple values, shorting on the first non-nil value.\n"],["from_value","Ronad::Many","Ronad/Many.html#method-i-from_value","(value)",""],["halt","Ronad::Maybe","Ronad/Maybe.html#method-i-halt","()","<p>“Fails” a maybe given a certain condition. If the condition is `true` then Maybe(nil) will …\n"],["method_missing","Ronad::Monad","Ronad/Monad.html#method-i-method_missing","(method, *args, &block)","<p>Provides convinience for chaining methods together while maintaining a monad.\n<p>@example Chaining fetches …\n"],["monad_value","Ronad::Default","Ronad/Default.html#method-i-monad_value","()","<p>@override\n"],["monad_value","Ronad::Eventually","Ronad/Eventually.html#method-i-monad_value","()","<p>@override\n"],["monad_value","Ronad::Just","Ronad/Just.html#method-i-monad_value","()","<p>@raise [Ronad::Just::CannotBeNil]\n"],["monad_value","Ronad::Many","Ronad/Many.html#method-i-monad_value","()","<p>Returns the underlying value of the many. Always an Enumerator, sometimes lazy. @see #initialize\n"],["monad_value","Ronad::Monad","Ronad/Monad.html#method-i-monad_value","()","<p>Extract the value from the monad. Can also be extracted via `~` unary operator.\n<p>@example\n\n<pre class=\"ruby\"><span class=\"ruby-operator\">~</span><span class=\"ruby-constant\">Maybe</span>(<span class=\"ruby-string\">&quot;hello&quot;</span>) <span class=\"ruby-operator\">...</span>\n</pre>\n"],["new","Ronad::Default","Ronad/Default.html#method-c-new","(fallback, value)","<p>@param fallback [Object] The value on which to fallback if the doesn&#39;t\n\n<pre class=\"ruby\"><span class=\"ruby-identifier\">satisfy</span> <span class=\"ruby-constant\">Just</span>(<span class=\"ruby-identifier\">value</span>)\n</pre>\n<p>@param value …\n"],["new","Ronad::Eventually","Ronad/Eventually.html#method-c-new","(block)",""],["new","Ronad::Just","Ronad/Just.html#method-c-new","(value)","<p>@raise [Ronad::Just::CannotBeNil] if value is provided as nil\n"],["new","Ronad::JustOne","Ronad/JustOne.html#method-c-new","(*args)",""],["new","Ronad::Many","Ronad/Many.html#method-c-new","(value, return_lazy: nil)","<p>Wraps a value in the Many monad.\n<p>@param value - Does not need to be an enumerable as\n\n<pre class=\"ruby\"><span class=\"ruby-identifier\">it</span> <span class=\"ruby-identifier\">will</span> <span class=\"ruby-identifier\">be</span> <span class=\"ruby-identifier\">wrapped</span> <span class=\"ruby-operator\">...</span>\n</pre>\n"],["new","Ronad::Monad","Ronad/Monad.html#method-c-new","(value)",""],["respond_to_missing?","Ronad::Monad","Ronad/Monad.html#method-i-respond_to_missing-3F","(method_name, include_private = false)",""],["value","Ronad::Monad","Ronad/Monad.html#method-i-value","()","<p>Extract the value from the monad. If the underlying value responds to #value then this will be bypassed …\n"]]}}